#!/bin/sh
# Copy Programmer-tm (Мотофан!)
# Radio+ (Больше, чем просто радио)
# Определим рабочую директорию:
mypath="${0%/*}"
# Получим заданную громкость:
vol=`"$mypath"/config_mgr.sh "$mypath"/cfg/radio.cfg vol`
# Сбросим уровни громкости:
killall soundmanager
# Получим заданный плейлист:
pls=`"$mypath"/config_mgr.sh "$mypath"/cfg/radio.cfg pls`
# Получим заданное значение для записи:
rec=`"$mypath"/config_mgr.sh "$mypath"/cfg/radio.cfg rec`
# Получим заданное значение для воспроизведения:
play=`"$mypath"/config_mgr.sh "$mypath"/cfg/radio.cfg play`
# Определим наличие системы iNative:
if find /ezxlocal/iNative/ -type d
then
	# Есть, коннектимся к wifi:
	(/ezxlocal/iNative/iNative.sh "-w" connect)&
	sleep 10
	# Протестим соединение...
	x="$?"
	elif [ "$x" = "1" ]
	then
		# Сообщение об ошибке...
		echo "<log> iNative: error connect to wi-fi" >> "$mypath"/log/plan_log.txt
		exit 1	
else
	# Нет, пишем в лог ошибку и на выход:
	echo "<log> iNative: not found, error..." >> "$mypath"/log/plan_log.txt
	exit 1
fi
# Опишем функцию скачивания файла из интернета по предоставленной ссылке (url) в определенную директорию, в рабочем каталоге.
download()
{
(wget -O "$mypath/records/$zap" "$url")&
}
# Опишем функцию запроса даты, получения имени файла без расширения, и формирования общего имени для файла в локальном хранилище.
dat()
{
# Формируем дату для имени файла:
dat=`date +%d.%m.%g_%H.%M.%S-`
# Получаем url адрес из файла:
url=`cat "$mypath"/playlists/"$pls"`
# Получаем расширение файла:
ras="${url##*.}"
# Формируем имя файла записи:
zap="$dat${pls%.*}.$ras"
# Отправляем название записи в конфиг:
"$mypath"/config_mgr.sh "$mypath"/cfg/radio.cfg zap "$zap"
}
# запустим функцию получения всех параметров:
dat
# Включим запись:
# Проверим на необходимость проигрывания:
if [ "$play" = "1" ]
then
download
sleep 4
/usr/SYSqtapp/phone/alertprocess -playvol "$vol" -playfile "$mypath/records/$zap" -playdev "1" -playlevel "257" -playRampUpVol "0" -playMode "1"
elif [ "$rec" = "1" ]
then
download
else
echo "<log> iRadio: not founf function rec..." >> "$mypath"/log/plan_log.txt
("$mypath"/iRadio_off.sh)&
exit 1
fi