#!/bin/sh
# Планировщик задач для приложений MagX платформы.
# Первое, что мы делаем, врубаем разгон:
pmtool -s
# И проверяем, включился ли он...
if [ "$?" = "0" ]
then
# Если нет, то стартуем его заново.
pmtool -s
fi
# Определим рабочую директорию:
mypath="${0%/*}"
# Опишем службу для работы с датами:
sluzhba()
{
# Получим заданную дату:
Data=`"$mypath"/config_mgr.sh "$mypath"/cfg/plan.cfg Data`
# Проведем проверку на пустоту:
if [ "$Data" = "" ]
then
echo "<Plan> Plan: Error, date not found..." >> "$mypath"/log/plan_log.txt
Spisok=`"$mypath"/config_mgr.sh "$mypath"/cfg/plan.cfg Spisok`
# Проверим список на пустоту!
	if [ "$Spisok" = "" ]
	then
		echo "<Plan> Plan: Error, Spisok not found. Exit..." >> "$mypath"/log/plan_log.txt
		exit "1"
	else
		("$mypath"/spisok.sh)&
		exit
	fi
else
	# Разбиваем дату на месяцы и числа:
	m=`echo "${Data#*.}" | sed -e 's/^[0]*//'`
	d=`echo "${Data%.*}" | sed -e 's/^[0]*//'`
	# Получим текущие дату и время:
	m1=`date +%m | sed -e 's/^[0]*//'`
	d1=`date +%d | sed -e 's/^[0]*//'`
	# Выполним проверку: 
	if [ "$m1" -lt "$m" ]
	then
		# Месяц меньше задуманного - спим и рестарт службы:
		sleep 60
		sluzhba
	else
		if [ "$m1" -eq "$m" ]
		then
			if [ "$d1" -lt "$d" ]
			then
				# День меньше задуманного - спим и рестарт службы:
				sleep 60
				sluzhba
			else
				if [ "$d1" -eq "$d" ]
				then
					# День равен задуманному - старт таймера:
					("$mypath"/timer.sh)&
					exit
				else
					# День больше задуманного - спим и рестарт службы:
					echo "<$d1.$m1> Plan: day passed; start replace day, month, times" >> "$mypath"/log/plan_log.txt
					("$mypath"/spisok.sh)&
					exit
				fi
			fi
		else
			# Месяц больше задуманного - спим и рестарт службы:
			echo "<$d1.$m1> Plan: month passed; start replace day, month, times" >> "$mypath"/log/plan_log.txt
			("$mypath"/spisok.sh)&
			exit
		fi
	fi
fi
}
sluzhba
# Выключаем разгон
pmtool -s
if [ "$?" = "255" ]
then
# Повтор, если не выполнено:
pmtool -s
fi
