#!/bin/sh
# Таймер для приложений MagX платформы.
# Первое, что мы делаем, врубаем разгон:
pmtool -s
# И проверяем, включился ли он...
if [ "$?" = "0" ]
then
# Если нет, то стартуем его заново.
pmtool -s
fi
# Определим рабочую директорию:
mypath="${0%/*}"
# Опишем службу для работы с датами:
sluzhba()
{
# Опишем функцию перевода часов в число:
chaschislo()
{
# Убираем ":" и лишние "0":
chas=`echo "$1" | sed s/:// | sed -e 's/^[0]*//'`
# Восстановим 0 если совсем пусто:
if [ "$chas" = "" ]
then
# Восстановим 0 если совсем пусто:
chas="0"
fi
}
# Опишем логику взаимодействия с подсчетом времени:
logick()
{
# заберем число:
x="$1"
# сравним с 0:
if [ "$x" = "0" ]
then
	# Если равно, то интервал в 10 минут от сих до сих...
    x=2355
    y=5
elif [ "$x" -eq "5" ]
then
    # Если равно 5, то интервал в 10 минут от сих до сих...
	x=0
	y=10
elif [ "$x" -le "54" ]
then
	# Если до 54, то интервал в 10 минут от сих до сих...
	let y=$x+5
    let x=$x-5
# Если больше 54, то..
else
	# Если больше 54, то...
	# Сформируем некий тест - минуты в часах
	test=`echo "$x" | sed -nr 's/.*(..)$/\1/p'`
	test=`echo "$test" | sed -e 's/^[0]*//'`
	# сравним с 0 и получим диапазоны по аналогии:
	if [ "$test" = "" ]
	then
		let y=$x+5
		let x=$x-100+60-5
	elif [ "$test" -lt "5" ]
	then
		let y=$x+5
		let x=$x-100+60-5
	else
		let y=$test+5
		if [ "$y" -ge "60" ]
		then
			let y=$x+5-$y+$y-60+100
			elif [ "$y" -ge "2400" ]
			then
				let y=$y-2400
			else
				let y=$x+5
		fi
		let x=$x-5
	fi
fi
}
# Получим текущее время и скормим преобразователю:
chaschislo `date +%H:%M`
# Запишем его для дальнейшей работы:
chas1="$chas"
z=`"$mypath"/config_mgr.sh "$mypath"/cfg/plan.cfg Vremya`
if [ "$z" = "" ]
then
	echo "<$chas1> Timer: Error, time is null. Exit" >> "$mypath"/log/plan_log.txt
	exit 1
else
	# Получим заданное время и скормим преобразователю:
	chaschislo "$z"
	# Скормим время функции логики:
	logick "$chas"
	# Дальнейшая работа:
	# Если текущее время находится в заданном диапазоне, то:
	if [ "$x" -le "$chas1" ]
	then
		if [ "$y" -ge "$chas1" ]
		then
			# Время входит в диапазон, значит запустим ПО, прописанное в конфиге:
			("$mypath"/stop.sh)&
			exit
		else
			# Время просрано, вернемся в планировщик через список:
			echo "<$chas1> Timer: day passed; start replace day, month, times, started plan..." >> "$mypath"/log/plan_log.txt
			("$mypath"/spisok.sh)&
			exit
		fi
	else
		# Время еще не пришло, бум ждать:
		sleep 30
		sluzhba
	fi
fi
}
sluzhba
# Выключаем разгон
pmtool -s
if [ "$?" = "255" ]
then
# Повтор, если не выполнено:
pmtool -s
fi